/*
			       X-P-POS
  
  Dieses Programm dient dazu den Pointer auf einem X-Window-Terminal
  an eine bestimmte Position zu setzen.
  Angegeben werden kann der Display, auf dem der Pointer gesetzt
  werden soll und die Position.
  Die Position kann absolut von der rechten oberen, oder unteren
  linken Kante aus gesetzt werden.

  Der Aufruf erfolgt mit:

    xppos [-dDISPLAY] [-pPOSITION]

  Werden keine Angaben gemacht, dann wird der Pointer auf dem
  aktuellen Display an die Position (0, 0) (=obere rechte Ecke)
  gesetzt.
*/

#include	<stdio.h>
#include	<X11/Xlib.h>

void main(int argc, char *argv[]){

  /* Variablen */
  int		posx, posy;		/* Pointerposition	*/
  char		*dpn;			/* Displayname		*/
  char		*argp;			/* Argumentpointer	*/
  char		minus;			/* Haelt Vorzeichen	*/
  int		i;			/* Zaehlvariable	*/

  Display	*dsp;			/* Zeiger auf Display	*/
  int		sn;			/* Screennummer		*/
  Window	root;			/* RootWindow		*/
  int		dbreite, dhoehe;	/* Breite und Hoehe des */
  					/* Displays		*/

  /* Interpretation der Argumente */
  /* Zunaechst Setzung der Defaults */
  posx=0; posy=0;
  dpn=NULL;

  for (i=2; i<=argc; i++){
    argp=argv[i-1];
    if (*argp=='-'){
      argp++;
      switch (*argp){
        case 'd' : {argp++; dpn=argp; break;}
	case 'p' : {argp++;
		    if (*argp=='-') minus=1; else minus=0;
		    argp++;
		    while ((*argp <= '9') && (*argp >= '0')){
		      posx*=10;
		      posx=posx+*argp-'0';
		      argp++;}
		    if (minus) posx=-posx;
		    if (*argp=='-') minus=1; else minus=0;
		    argp++;
		    while ((*argp <= '9') && (*argp >= '0')){
		      posy*=10;
		      posy=posy+*argp-'0';
		      argp++;}
		    if (minus) posy=-posy;}}}
    else printf("Fehlerhaftes Argument: %s\n", argp);}

  /* Nun sind Display und Position bekannt
     Es werden jetzt die Verbindung zum X-Server ge\"offnet und die
     Breite und die Hoehe des Displays ermittelt. */
  dsp=XOpenDisplay(dpn);
  if (dsp != NULL){
    sn=DefaultScreen(dsp);
    dbreite=DisplayWidth(dsp, sn);
    dhoehe=DisplayHeight(dsp, sn);
    if (posx < 0) posx=dbreite+posx;
    if (posy < 0) posy=dhoehe+posy;

    if (posx < 0) posx=0;
    if (posy < 0) posy=0;
    if (posx > dbreite) posx=dbreite-1;
    if (posy > dhoehe) posy=dhoehe-1;
    root=RootWindow(dsp, sn);
    XWarpPointer(dsp, None, root, 0, 0, 0, 0, posx, posy);
    XCloseDisplay(dsp);
  }
  else printf("Keine Verbindung zum X-Server!\n");}

